<?php

namespace Drupal\lingotek_overrides;

use Drupal\lingotek\LingotekInterface as BaseLingotekInterface;

/**
 * Interface for the extended Lingotek service.
 *
 * @package Drupal\lingotek_overrides
 */
interface LingotekInterface extends BaseLingotekInterface {

  /**
   * Gets the Lingktek API object.
   *
   * @return \Drupal\lingotek_overrides\Remote\LingotekApiInterface
   */
  public function getApi();

  /**
   * Makes a GET call to the /document/{id}/translation endpoint.
   * @param $id
   *
   * @return mixed
   */
  public function getTranslation($id);

  /**
   * Makes a GET call to the /document/{id}/content endpoint.
   *
   * @param $id
   *
   * @return mixed
   */
  public function getFile($id);

  /**
   * Gets the phases of a translation.
   *
   * @param $id
   *
   * @return mixed
   */
  public function getPhases($id);

  /**
   * Makes a GET call to the /task/{id}/content endpoint.
   *
   * @param $id
   *   The task ID.
   *
   * @return mixed
   *   The task content.
   */
  public function getTaskContent($id);

  /**
   * Makes a PATCH call to the /task/{id}/content endpoint.
   *
   * @param $id
   * @param $data
   *
   * @return mixed
   */
  public function patchTaskContent($id, $data);

}
